#! /usr/local/bin/python
#
# paned_window.py - demo of the PanedWindow widget
#

import TkXtra
tkx=TkXtra

EXPLANATION = """This is a TkXtra PanedWindow widget. The panes may be
organized horizontally or vertically. Each pane may be assigned
a minimum size (50, 100 and 150 here)."""

CONTENTS = """
  When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it
in new free programs; and that you know you can do these things.

  To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

  For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.
"""

class Demo:
    def __init__(self, root):
	self.master = root
	self.msg = tkx.Label(root, text=EXPLANATION)
	self.msg.pack(side=tkx.TOP, expand=0, fill=tkx.X)
	btns = tkx.ButtonBox(root, orient=tkx.HORIZONTAL)
	btns.add(text='Horizontal Panes', command=self.horiz)
	btns.add(text='Vertical Panes', command=self.vert)
	btns.add(text='Dismiss', command=self.exit)
	btns.pack(side=tkx.TOP, expand=0, fill=tkx.X)
	self.paned = tkx.PanedWindow(root)
	self.paned.add_pane('1', min_size=50)
	self.paned.add_pane('2', min_size=100)
	self.paned.add_pane('3', min_size=150)
	self.s1 = tkx.ScrolledText(self.paned.pane('1'))
	self.s2 = tkx.ScrolledText(self.paned.pane('2'))
	self.s3 = tkx.ScrolledText(self.paned.pane('3'))
	self.s1.text.insert(tkx.END, CONTENTS)
	self.s2.text.insert(tkx.END, CONTENTS)
	self.s3.text.insert(tkx.END, CONTENTS)
	self.s1.pack(expand=1, fill=tkx.BOTH)
	self.s2.pack(expand=1, fill=tkx.BOTH)
	self.s3.pack(expand=1, fill=tkx.BOTH)
	self.paned.pack(side=tkx.BOTTOM, expand=1, fill=tkx.BOTH)

    def exit(self, event=None):
	self.master.destroy()

    def horiz(self, event=None):
	if self.paned['orient'] != tkx.HORIZONTAL:
	    self.paned['orient'] = tkx.HORIZONTAL

    def vert(self, event=None):
	if self.paned['orient'] != tkx.VERTICAL:
	    self.paned['orient'] = tkx.VERTICAL

def RunSample(root):
    root.minsize(10, 10)
    demo = Demo(root)
    root.mainloop()

if __name__ == '__main__':
    RunSample(tkx.Tk())
